global regcount tdrtable() EGreport LItable()
set LogFlag 1
set EGreport 0

# Register and RAM table: Name : Offset address : Nbits : Nlocs 
set tdrtable(0)		{"Reject Delay      "   0x0000 8 1   }
set tdrtable(1)		{"Control           "   0x0002 3 1   }

set regcount 2


# A simple read at each of the base addresses
proc test1 {} {
global regcount tdrtable
	for {set i 0} {$i < $regcount} {incr i} {
	set reg_address [ lindex $tdrtable($i) 1 ]
	rdw $reg_address
	}
}
# Addressing test       addressing in words.
proc test2 {} {
global regcount tdrtable LogFlag EGreport
	set LogFlag 0 
	set EGreport -1
	for {set i 0} {$i < $regcount} {incr i} {
	   set reg_address [ lindex $tdrtable($i) 1 ]
	   set nlocs [lindex $tdrtable($i) 3 ] 
	   for { set j 0} { $j < $nlocs } {incr j } {
		wrw $reg_address $j
		set reg_address [ expr  $reg_address +  2  ]
	   }
	}
	log { All writes done for Identity test }
	update idletasks
	for {set i 0} {$i < $regcount} {incr i} {
	   set reg_address [ lindex $tdrtable($i) 1 ]
	   set nlocs [ lindex $tdrtable($i) 3 ] 
	   set nbits [ lindex $tdrtable($i) 2 ] 
	   for { set j 0} { $j <  $nlocs } {incr j } {
		set b [rdw $reg_address]
		set mask [ expr 1 << $nbits ]
		set mask [ expr $mask -1 ]
		set b [ expr $b & $mask ]
		set a [ expr $j & $mask ]
		if { $b != $a } {
		  log "[ lindex $tdrtable($i) 0 ] [format "0x%04x" $reg_address] [format "0x%08x" $a] [format "0x%08x" $b] "
		  update idletasks
		}
		set reg_address [ expr  $reg_address + 2]
	   }
	}
	log { All Reads done for Identity test }
	update idletasks
}
# Running ones, and noughts test
proc test3 {} {
global regcount tdrtable LogFlag EGreport
	set LogFlag 0 
	set EGreport -1
	for { set i 0} { $i < $regcount } { incr i } {
	   log "[lindex $tdrtable($i) 0]"
	   update idletasks
	   set reg_address [ lindex $tdrtable($i) 1 ]
	   set nlocs [ lindex $tdrtable($i) 3 ] 
	   set nbits [ lindex $tdrtable($i) 2 ] 
	   set mask  [ expr 1 << $nbits ]
	   set mask  [ expr $mask -1 ]
	   for { set j 0 } { $j < $nlocs } { incr j } {
		set l 1
		for { set k 0 } { $k < $nbits } { incr k } {
		    wrw $reg_address $l
		    set b [rdw $reg_address]
		    set b [ expr $b & $mask ]
		    set a [ expr $l & $mask ]
		    if { $b != $a } {
		      log "[ lindex $tdrtable($i) 0 ] [format "0x%04x" $reg_address] [format "0x%08x" $a] [format "0x%08x" $b] "
		      update idletasks
		    }
		    set l [expr $l << 1 ]
		}
		wrw $reg_address 0 ;# to catch the board reset bits
		set reg_address [ expr  $reg_address + 2]
	   }
	   set reg_address [ lindex $tdrtable($i) 1 ]
	   for { set j 0 } { $j < $nlocs } { incr j } {
		set l -2
		for { set k 0 } { $k < $nbits } { incr k } {
		    wrw $reg_address $l
		    set b [rdw $reg_address]
		    set b [ expr $b & $mask ]
		    set a [ expr $l & $mask ]
		    if { $b != $a } {
		      log "[ lindex $tdrtable($i) 0 ] [format "0x%04x" $reg_address] [format "0x%08x" $a] [format "0x%08x" $b] "
		      update idletasks
		    }
		    set l [expr ( $l << 1 ) + 1]
		}
		wrw $reg_address 0 ;# to catch the board reset bits
		set reg_address [ expr  $reg_address + 2]
	   }
	}
}

# Running the tests
set-busy
test1
test2
test3

set LogFlag 1
set EGreport 0
clear-busy
log {That's all Folks !}
update idletasks
